# A PHP Client for the Hetzner DNS API

[Hetzner](https://dns.hetzner.com) is a hosting provider, which offers a REST API for their DNS service.

This SDK has been generated with [JanePHP](https://github.com/janephp/janephp) using the provided API [documentation](https://dns.hetzner.com/api-docs/).

The generated client has been modified to throw exceptions in case of an error answer.

## Installation

You will need a PSR-18 compatible client implementation. We used [symfony/http-client](https://github.com/symfony/http-client).

Most probably your framework already has some client instantiated, you just can pass to the Openapi client.

## Notes

1. As the DateFormat from Hetzner is not consistent (sometimes it shows microseconds, sometimes not, and in verified fields there is even more trailing information) you might want to add the HetznerDatesPlugin to your HTTP-Client. It's job is to replace all date strings with a consistent form (you'll loose the microseconds fractions from DateTimes, which have one)
2. The original hetzner OpenAPI specification mentions the Auth-API-Token as header parameter of each request, instead of applying the security scheme globally. To have a more sophisticated client, this has been rewritten. (Diff `hetzner-dns-api.json` with `hetzner-dns-api-modified.json`)
