<?php

namespace DigiComp\HetznerDnsApi\Endpoint;

class CreateZone extends \DigiComp\HetznerDnsApi\Runtime\Client\BaseEndpoint implements \DigiComp\HetznerDnsApi\Runtime\Client\Endpoint
{
    /**
     * Creates a new zone.
     *
     * @param null|\DigiComp\HetznerDnsApi\Model\Zone $requestBody 
     */
    public function __construct(?\DigiComp\HetznerDnsApi\Model\Zone $requestBody = null)
    {
        $this->body = $requestBody;
    }
    use \DigiComp\HetznerDnsApi\Runtime\Client\EndpointTrait;
    public function getMethod() : string
    {
        return 'POST';
    }
    public function getUri() : string
    {
        return '/zones';
    }
    public function getBody(\Symfony\Component\Serializer\SerializerInterface $serializer, $streamFactory = null) : array
    {
        if ($this->body instanceof \DigiComp\HetznerDnsApi\Model\Zone) {
            return array(array('Content-Type' => array('application/json')), $serializer->serialize($this->body, 'json'));
        }
        return array(array(), null);
    }
    public function getExtraHeaders() : array
    {
        return array('Accept' => array('application/json'));
    }
    /**
     * {@inheritdoc}
     *
     * @throws \DigiComp\HetznerDnsApi\Exception\CreateZoneUnauthorizedException
     * @throws \DigiComp\HetznerDnsApi\Exception\CreateZoneNotAcceptableException
     * @throws \DigiComp\HetznerDnsApi\Exception\CreateZoneUnprocessableEntityException
     *
     * @return null|\DigiComp\HetznerDnsApi\Model\ZonesPostResponse200
     */
    protected function transformResponseBody(string $body, int $status, \Symfony\Component\Serializer\SerializerInterface $serializer, ?string $contentType = null)
    {
        if (is_null($contentType) === false && (200 === $status && mb_strpos($contentType, 'application/json') !== false)) {
            return $serializer->deserialize($body, 'DigiComp\\HetznerDnsApi\\Model\\ZonesPostResponse200', 'json');
        }
        if (401 === $status) {
            throw new \DigiComp\HetznerDnsApi\Exception\CreateZoneUnauthorizedException();
        }
        if (406 === $status) {
            throw new \DigiComp\HetznerDnsApi\Exception\CreateZoneNotAcceptableException();
        }
        if (422 === $status) {
            throw new \DigiComp\HetznerDnsApi\Exception\CreateZoneUnprocessableEntityException();
        }
    }
    public function getAuthenticationScopes() : array
    {
        return array('Auth-API-Token');
    }
}