<?php

namespace DigiComp\HetznerDnsApi\Model;

class BasePrimaryServer
{
    /**
     * ID of zone this record is associated with
     *
     * @var string|null
     */
    protected $zoneId;
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @var string|null
     */
    protected $address;
    /**
     * Port number of the primary server
     *
     * @var int|null
     */
    protected $port;
    /**
     * ID of zone this record is associated with
     *
     * @return string|null
     */
    public function getZoneId() : ?string
    {
        return $this->zoneId;
    }
    /**
     * ID of zone this record is associated with
     *
     * @param string|null $zoneId
     *
     * @return self
     */
    public function setZoneId(?string $zoneId) : self
    {
        $this->zoneId = $zoneId;
        return $this;
    }
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @return string|null
     */
    public function getAddress() : ?string
    {
        return $this->address;
    }
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @param string|null $address
     *
     * @return self
     */
    public function setAddress(?string $address) : self
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Port number of the primary server
     *
     * @return int|null
     */
    public function getPort() : ?int
    {
        return $this->port;
    }
    /**
     * Port number of the primary server
     *
     * @param int|null $port
     *
     * @return self
     */
    public function setPort(?int $port) : self
    {
        $this->port = $port;
        return $this;
    }
}