<?php

namespace DigiComp\HetznerDnsApi\Normalizer;

use Jane\Component\JsonSchemaRuntime\Reference;
use DigiComp\HetznerDnsApi\Runtime\Normalizer\CheckArray;
use Symfony\Component\Serializer\Exception\InvalidArgumentException;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class ZonesGetResponse200Normalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    use CheckArray;
    public function supportsDenormalization($data, $type, $format = null) : bool
    {
        return $type === 'DigiComp\\HetznerDnsApi\\Model\\ZonesGetResponse200';
    }
    public function supportsNormalization($data, $format = null) : bool
    {
        return is_object($data) && get_class($data) === 'DigiComp\\HetznerDnsApi\\Model\\ZonesGetResponse200';
    }
    /**
     * @return mixed
     */
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (isset($data['$ref'])) {
            return new Reference($data['$ref'], $context['document-origin']);
        }
        if (isset($data['$recursiveRef'])) {
            return new Reference($data['$recursiveRef'], $context['document-origin']);
        }
        $object = new \DigiComp\HetznerDnsApi\Model\ZonesGetResponse200();
        if (null === $data || false === \is_array($data)) {
            return $object;
        }
        if (\array_key_exists('zones', $data) && $data['zones'] !== null) {
            $values = array();
            foreach ($data['zones'] as $value) {
                $values[] = $this->denormalizer->denormalize($value, 'DigiComp\\HetznerDnsApi\\Model\\ZoneResponse', 'json', $context);
            }
            $object->setZones($values);
        }
        elseif (\array_key_exists('zones', $data) && $data['zones'] === null) {
            $object->setZones(null);
        }
        if (\array_key_exists('meta', $data) && $data['meta'] !== null) {
            $object->setMeta($this->denormalizer->denormalize($data['meta'], 'DigiComp\\HetznerDnsApi\\Model\\Meta', 'json', $context));
        }
        elseif (\array_key_exists('meta', $data) && $data['meta'] === null) {
            $object->setMeta(null);
        }
        return $object;
    }
    /**
     * @return array|string|int|float|bool|\ArrayObject|null
     */
    public function normalize($object, $format = null, array $context = array())
    {
        $data = array();
        if (null !== $object->getZones()) {
            $values = array();
            foreach ($object->getZones() as $value) {
                $values[] = $this->normalizer->normalize($value, 'json', $context);
            }
            $data['zones'] = $values;
        }
        if (null !== $object->getMeta()) {
            $data['meta'] = $this->normalizer->normalize($object->getMeta(), 'json', $context);
        }
        return $data;
    }
}